/***************************************************************************
 *   Copyright (C) 2005 by JSRiera								    	   *
 *   http://www.xtec.cat/dnee/udc/english/main.html                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 *   YOU CAN NOT USE THIS SOURCE FILE OR MODIFIED VERSION FOR ANY          *
 *   COMMERCIAL PRODUCTS!                                                  *
 *                                                                         *
 ***************************************************************************/

#include "CTransform.h"

CTransform::CTransform()
{
	dof2 = 8;
	for(int i=0;i<8;i++) {
		for (int j=0;j<16;j++) {
			off[i][j] = 0;
		}
	}
	for(int k=0;k<8;k++) {
		for (int l=0;l<16;l++) {
			sff[k][l] = 0;
		}
	}
	for(int m=0;m<8;m++) {
		for (int n=0;n<16;n++) {
			sffi[m][n] = 0;
		}
	}
	for(int p=0;p<8;p++) {
			param[p] = 0;
	}


}

CTransform::~CTransform ()
{
}

double CTransform::multiplicar_matriu (int c, int f)
{
	int i;
	double d;
	for (i=0; i<dof2;i++) {
		d = d + (off[i][f] * sffi[c][i]);
	}
	return d;
}

int CTransform::non_zero (int row, int col)
{
	for (int x=row; x<dof2; x++) {
		if (sff[x][col] != 0 ) 
			return x;
	}
}

int CTransform::shuffle_row (int desti, int origen)
{
	double d;
	int y;
	for (y=0; y<2*dof2;y++) {
		d = sff[desti][y];
		sff[desti][y] = sff[origen][y];
		sff[origen][y] = d;
	}
	return 0;
}

double CTransform::ulldc_matriu_x (int x, int y)
{
	double d;
	d = (param[0]*x+param[1]*y+param[2])/(param[6]*x+param[7]*y + 1);
	return d;
}

double CTransform::ulldc_matriu_y (int x, int y)
{
	double d;
	d = (param[3]*x+param[4]*y+param[5])/(param[6]*x+param[7]*y + 1);
	return d;
}

void CTransform::inverse ()
{
	int first, x, y;
	double temp;
	double tempA[8][16];
	int cRow;

	for (int n=0;n<8;n++) {
		for (int m=0; m<16;m++) {
			tempA[n][m] = 0;
		}
	}

	for (y=0; y <dof2;y++) {
		for (x=0; x<dof2; x++) {
			sff[y][x] = off[y][x];
		}
	}
	x = 0;
	for (cRow=dof2;cRow<2*dof2;cRow++) {
		sff[x][cRow] = 1;
		x = x+1;
	}

	for (cRow=0; cRow<dof2;cRow++) {

		if (sff[cRow][cRow] == 0 ) {
			first = non_zero(cRow, cRow);
			shuffle_row(cRow, first);
		}

		temp = sff[cRow][cRow];
		for (x=cRow; x<dof2*2;x++) {
			sff[cRow][x] = (sff[cRow][x]/temp);
		}

		if (cRow == 0) {
			for (y=1;y<dof2;y++) {
				for (x=0;x<dof2*2;x++) {
					tempA[y][x] = sff[0][x]*sff[y][0];
				}
			}
			for (y=1;y<dof2;y++) {
				for (x=0;x<dof2*2;x++) {
					sff[y][x] = sff[y][x] - tempA[y][x];
				}
			}
		} else {
			if (cRow == dof2-1) {
				for (y=0;y<dof2-1;y++) {
					for (x=0;x<dof2*2;x++) {
						tempA[y][x] = sff[dof2-1][x]*sff[y][dof2-1];
					}
				}
				for (y=0;y<dof2-1;y++) {
					for (x=0;x<dof2*2;x++) {
						sff[y][x] = sff[y][x] - tempA[y][x];
					}
				}
			} else {
				for (y=cRow+1;y<dof2;y++){
					for (x=0;x<dof2*2;x++) {
						tempA[y][x] = sff[cRow][x]*sff[y][cRow];
					}
				}
				for (y=cRow+1;y<dof2;y++){
					for (x=0;x<dof2*2;x++) {
						sff[y][x] = sff[y][x] -tempA[y][x];
					}
				}
				for (y=0;y<cRow-1;y++) {
					for(x=0;x<dof2*2;x++) {
						tempA[y][x] = sff[cRow][x]*sff[y][cRow];
					}
				}
				for (y=0;y<cRow-1;y++) {
					for(x=0;x<dof2*2;x++) {
						sff[y][x] = sff[y][x] -tempA[y][x];
					}
				}
			}
		}
	}		
}

void CTransform::calcul_param ()
{
	int x;
	for (x=0;x<dof2;x++) {
		param[x] = sffi[0][x]*0+sffi[1][x]*0+sffi[2][x]*640+sffi[3][x]*0+sffi[4][x]*640+sffi[5][x]*480+sffi[6][x]*0+sffi[7][x]*480;
	}
}

int CTransform::inici_calcul_matriu (int p1x, int p1y, int p2x, int p2y,
int p3x, int p3y, int p4x, int p4y, int width, int height)
{
	int inv = 7;
	if (omplir_matriu(p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y, width, height) == 0) return 0;

	inverse();

	for (int inn=0; inn<dof2;inn++) {
		inv = dof2-1;
		for(int out= 0; out<dof2; out++) {
			inv = inv+1;
			sffi[inn][out] = sff[inn][inv];
		}
	}
	
	calcul_param ();
	return 1;
}

int CTransform::omplir_matriu (int p1x, int p1y, int p2x, int p2y,
int p3x, int p3y, int p4x, int p4y, int width, int height)
{
	off[0][0] = p1x; 
	off[1][0] = p1y; 
	off[2][0] = 1;
	off[3][1] = off[0][0]; 
	off[4][1] = off[1][0]; 
	off[5][1] = 1;
	off[0][2] = p2x; 
	off[1][2] = p2y; 
	off[2][2] = 1;
	off[6][2] = -width * off[0][2];
	off[7][2] = -width * off[1][2];
	off[3][3] = off[0][2];
	off[4][3] = off[1][2];
	off[5][3] = 1;
	off[0][4] = p3x; 
	off[1][4] = p3y; 
	off[2][4] = 1;
	off[6][4] = -width * off[0][4]; 
	off[7][4] = -width * off[1][4]; 
	off[3][5] = off[0][4]; 
	off[4][5] = off[1][4]; 
	off[5][5] = 1;
	off[6][5] = -height * off[0][4]; 
	off[7][5] = -height * off[1][4]; 
	off[0][6] = p4x; 
	off[1][6] = p4y; 
	off[2][6] = 1;
	off[3][7] = off[0][6]; 
	off[4][7] = off[1][6]; 
	off[5][7] = 1;
	off[6][7] = -height * off[0][6]; 
	off[7][7] = -height * off[1][6]; 
	return 1;
}
