/***************************************************************************
 *   Copyright (C) 2005 by JSRiera			                               *
 *   http://www.xtec.cat/dnee/udc/english/main.html		          		   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 *   YOU CAN NOT USE THIS SOURCE FILE OR MODIFIED VERSION FOR ANY          *
 *   COMMERCIAL PRODUCTS!                                                  *
 *                                                                         *
 ***************************************************************************/

#include "ThreadJoystick.h"


MyJoystickThread::MyJoystickThread(CImgProc *cam)
        : wxThread()
{
    m_cam = cam;
	wxFileConfig *pConfig = new wxFileConfig(wxT("Emulador"), wxT("Educaci"),
		wxT(".emulator_config"), wxEmptyString, wxCONFIG_USE_LOCAL_FILE | wxCONFIG_USE_NO_ESCAPE_CHARACTERS | wxCONFIG_USE_RELATIVE_PATH);
	pConfig->Read(wxT("Temps Espera"), &m_tespera, wxT("2000"));
	pConfig->Read(wxT("Temps Repeticio"), &m_trepeticio, wxT("4000"));
	pConfig->Read(wxT("Clic"), &m_clic, false);
	pConfig->Read(wxT("Clic Dreta"), &m_clic_dreta, false);
	pConfig->Read(wxT("Doble Clic"), &m_dbl_clic, false);
	pConfig->Read(wxT("No Clic"), &m_no_clic, false);
	pConfig->Read(wxT("Mostrar Clic"), &m_mostrar, true);
	pConfig->Read(wxT("Avis Sonor"), &m_avis, true);
	pConfig->Read(wxT("Invertir Vertical"), &m_vert, true);
	pConfig->Read(wxT("Invertir Horitzontal"), &m_horz, false);
	pConfig->Read(wxT("JTempsAcc"), &m_tacc, false);
	pConfig->Read(wxT("JPosAcc"), &m_pacc, true);
	pConfig->Read(wxT("JTempsAccVal"), &m_tacc_val, wxT("8"));
	pConfig->Read(wxT("JPosAccVal"), &m_pacc_val, wxT("8"));
	pConfig->Read(wxT("Sleep"), &gSleep, wxT("35"));
	pConfig->Read(wxT("RF"), &gRf, false);
	pConfig->Read(wxT("Jup"), &up, wxT("1"));
	pConfig->Read(wxT("Jdown"), &down, wxT("4"));
	pConfig->Read(wxT("Jleft"), &left, wxT("2"));
	pConfig->Read(wxT("Jright"), &right, wxT("3"));
	pConfig->Read(wxT("Jclick"), &click, wxT("5"));
	pConfig->Read(wxT("Jstep"), &step, wxT("5"));
	delete pConfig;
	
	Display *dpy1 = XOpenDisplay(0);
	assert(dpy1);
	Window root_window1 = XRootWindow(dpy1, 0);
	XWindowAttributes att;
	XGetWindowAttributes(dpy1, root_window1, &att);
    hw = att.height;
    ww = att.width;
  	XCloseDisplay(dpy1);

        
}

void MyJoystickThread::OnExit()
{
}

void *MyJoystickThread::Entry()
{
	wxFileConfig *pConfig = new wxFileConfig(wxT("Emulador"), wxT("Educaci"),
		wxT(".emulator_config"), wxEmptyString, wxCONFIG_USE_LOCAL_FILE | wxCONFIG_USE_NO_ESCAPE_CHARACTERS | wxCONFIG_USE_RELATIVE_PATH);
	pConfig->Read(wxT("BarHorz1"), &m_bh1, wxT("2"));
	pConfig->Read(wxT("BarHorz2"), &m_bh2, wxT("4"));
	pConfig->Read(wxT("BarVert1"), &m_bv1, wxT("1"));
	pConfig->Read(wxT("BarVert2"), &m_bv2, wxT("3"));
	delete pConfig;

    int fila, col, tenimImatge; 
	int pax, pay, px, py, cx, cy;
	int quad, quadAnt, incx, incy, l;
	int w, h;
    FT_HANDLE ftHandle;
    FT_STATUS ftStatus;
    DWORD RxBytes = 1;
    DWORD BytesReceived;
    char RxBuffer[256];
    DWORD EventDWord;
    DWORD TxBytes;

	l=0;
	quadAnt = 0;
	m_cam->GetFrameSize (&w, &h);
	cercle.GetMousePos(&px, &py);
	
    if (gRf) 
    {	
      m_mostrar = false;  
      ftStatus = FT_Open(0, &ftHandle);
	  if(ftStatus != FT_OK) {
	  // FT_Open failed
	    wxString msg;
	    msg.Printf(_T("Error opening RF device\n"));
		//printf("Error opening RF device\n");
	  }
    }
	

    while (1)
    {
		cercle.GetMousePos(&px, &py);

		cercle.GetMousePos(&cx, &cy);

		if ( TestDestroy() )
			break;

         FT_GetStatus(ftHandle,&RxBytes,&TxBytes,&EventDWord);
         if (RxBytes > 0) {
             ftStatus = FT_Read(ftHandle,RxBuffer,RxBytes,&BytesReceived);
             if (ftStatus == FT_OK) {
               	   if (BytesReceived == RxBytes) {
           	       // FT_Read OK
                   int num;
                   num = RxBuffer[0];
                   if (num == atoi(up))
                      ActualitzaPosJoystick(8, &cx, &cy, 0, atoi(step));
                   if (num == atoi(down))
                      ActualitzaPosJoystick(2, &cx, &cy, 0, atoi(step));
                   if (num == atoi(left))
                      ActualitzaPosJoystick(4, &cx, &cy, atoi(step), 0);
                   if (num == atoi(right))
                      ActualitzaPosJoystick(6, &cx, &cy, atoi(step), 0);
                   if (num == atoi(click))
                   cercle.EnviaClicRatoli(px, py, m_clic, m_clic_dreta, 
                                                              m_dbl_clic, m_no_clic);                                                    
		     cercle.SetMousePos(cx, cy);
             }
             }
             else {
                  // FT_Read Failed
             }
        } 

           
		tenimImatge = m_cam->GetColorPosition (0, &col, &fila);
        
		if (tenimImatge) {
			// si movem el cursor, borrem el que teniem dibuixat
			if ((pax != px) || (pay != py)) { 
                if ( m_mostrar )           
			        cercle.EraseScreen();
            } else {
                if ( m_mostrar )
                {   
       				if (cercle.DrawScreen(atoi(m_tespera), atoi(m_trepeticio), px, py))
				    {
                       if (!gRf)                                    
                       cercle.EnviaClicRatoli(px, py, m_clic, m_clic_dreta, 
                                                              m_dbl_clic, m_no_clic);                                   
                       if ( m_avis ) wxBell();
                    }
                }
                else
                {                  
       				if (cercle.WaitClic(atoi(m_tespera), atoi(m_trepeticio)))
				    {
                       if (!gRf)                                    
                       cercle.EnviaClicRatoli(px, py, m_clic, m_clic_dreta, 
                                                              m_dbl_clic, m_no_clic);                                   
                       if ( m_avis ) wxBell();
                    }
                 }
            }
			// Calcula el quadrant en que ens trobem.
			// Ja t en compte si invertim els eixos
			quad = ObtenirQuadrant(fila, col, !m_horz,
					m_vert, atoi(m_bv1), atoi(m_bv2), atoi(m_bh1), atoi(m_bh2));
			
			// canviar rutina. Fer que quan entrem varis cops al
			// mateix quadrant llavors accelerem increment;
			if ( m_tacc ) {
				if (quadAnt == quad) {
					incx = (l + 1)/atoi(m_tacc_val);
					incy = (l + 1)/atoi(m_tacc_val);
					l++;
				} else {
					l = 0;
					incx = 0;
					incy = 0;
				}
			}
            if ( m_pacc ) {
				incx = ObtenirIncrementX(w/2, col, atoi(m_pacc_val));
				incy = ObtenirIncrementY(h/2, fila, atoi(m_pacc_val));
			}
			quadAnt = quad;

			ActualitzaPosJoystick(quad, &cx, &cy, incx, incy);
			cercle.SetMousePos(cx, cy);
		}      
		pax = px; pay = py;	
        usleep(atoi(gSleep)*1000);
    } 
    if (gRf)
        FT_Close(ftHandle);
    return NULL;
}

int MyJoystickThread::ObtenirQuadrant (int fila, int col, int hor, int ver,
								  int X1, int X2, int Y1, int Y2) {

	int quadrant=0;
	//int h, w;
	//m_cam->GetFrameSize (&w, &h);
								  
    //int h = m_cam->GetHeight();
    //int w = m_cam->GetWidth();
    //int h = 240;
    //int w = 320;

/*
       if ((Y2 - Y1) < 0) {
          int p;
          p= Y1;
          Y1 = Y2;
          Y2 = p;
       }

    if (hor) {
       X1 = w - X1;
       X2 = w - X2;
    }
             
    if (ver) {
//       Y1 = h - Y1;

       fila = h - fila;
       Y2 = h - Y2;
   }

    if (IsInside(col, fila, X1, Y2, X2-X1, 480-Y2)) wxBell();
     
    
    if (IsInside(col, fila, 0, 0, X1, Y1)) quadrant=1;
    if (IsInside(col, fila, X1, 0, X2-X1, Y1)) quadrant=2;
    if (IsInside(col, fila, X2, 0, w-X2, Y1)) quadrant=3;

    if (IsInside(col, fila, 0, Y1, X1, Y2-Y1)) quadrant=4;
    if (IsInside(col, fila, X1, Y1, X2-X1, Y2-Y1)) quadrant=5;
    if (IsInside(col, fila, X2, Y1, w-X2, Y2-Y1)) quadrant=6;

    if (IsInside(col, fila, 0, Y2, X1, h-Y2)) quadrant=7;
    if (IsInside(col, fila, X1, Y2, X2-X1, h-Y2)) quadrant=8;
    if (IsInside(col, fila, X2, Y2, w-X2, h-Y2)) quadrant=9;

return quadrant;
*/
       if ((Y2 - Y1) < 0) {
          int p;
          p= Y1;
          Y1 = Y2;
          Y2 = p;
       }
       if ((X2 - X1) < 0) {
          int p;
          p= X1;
          X1 = X2;
          X2 = p;
       }

	if ((hor == 1) && (ver == 0)) {
		if (fila < Y1) {
			if (col < X1) quadrant = 7;
			else if ((col >= X1) && (col < X2)) quadrant = 8;
			else if (col >= X2) quadrant = 9;
		} else if ((fila >= Y1) && (fila < Y2)) {
			if (col < X1) quadrant = 4;
			else if ((col >= X1) && (col < X2)) quadrant = 5;
			else if (col >= X2) quadrant = 6;
		} else if (fila >= Y2) {
			if (col < X1) quadrant = 1;
			else if ((col >= X1) && (col < X2)) quadrant = 2;
			else if (col >= X2) quadrant = 3;
		}
	} else if ((ver == 1) && (hor == 0)) {
		if (fila < Y1) {
			if (col < X1) quadrant = 3;
			else if ((col >= X1) && (col < X2)) quadrant = 2;
			else if (col >= X2) quadrant = 1;
		} else if ((fila >= Y1) && (fila < Y2)) {
			if (col < X1) quadrant = 6;
			else if ((col >= X1) && (col < X2)) quadrant = 5;
			else if (col >= X2) quadrant = 4;
		} else if (fila >= Y2) {
			if (col < X1) quadrant = 9;
			else if ((col >= X1) && (col < X2)) quadrant = 8;
			else if (col >= X2) quadrant = 7;
		}
	} else if ((hor == 1) && (ver == 1)) {
		if (fila < Y1) {
			if (col < X1) quadrant = 1;
			else if ((col >= X1) && (col < X2)) quadrant = 2;
			else if (col >= X2) quadrant = 3;
		} else if ((fila >= Y1) && (fila < Y2)) {
			if (col < X1) quadrant = 4;
			else if ((col >= X1) && (col < X2)) quadrant = 5;
			else if (col >= X2) quadrant = 6;
		} else if (fila >= Y2) {
			if (col < X1) quadrant = 7;
			else if ((col >= X1) && (col < X2)) quadrant = 8;
			else if (col >= X2) quadrant = 9;
		}
	} else {
		if (fila < Y1) {
			if (col < X1) quadrant = 9;
			else if ((col >= X1) && (col < X2)) quadrant = 8;
			else if (col >= X2) quadrant = 7;
		} else if ((fila >= Y1) && (fila < Y2)) {
			if (col < X1) quadrant = 6;
			else if ((col >= X1) && (col < X2)) quadrant = 5;
			else if (col >= X2) quadrant = 4;
		} else if (fila >= Y2) {
			if (col < X1) quadrant = 3;
			else if ((col >= X1) && (col < X2)) quadrant = 2;
			else if (col >= X2) quadrant = 1;
		}
	}
	return quadrant;

}

int MyJoystickThread::ObtenirIncrementX(int p_mig_x, int col, int acceleracio) {

	int incx, diff;

	diff = abs(p_mig_x-col);
	
	incx = ((diff*diff)/(acceleracio*1000));

	return incx;

}

int MyJoystickThread::ObtenirIncrementY(int p_mig_y, int fila, int acceleracio) {

	int incy, diff;

	diff = abs(p_mig_y-fila);
	
	incy = ((diff*diff)/(acceleracio*1000));

	return incy;

}


void MyJoystickThread::ActualitzaPosJoystick(int quad, int *x, int *y, int incx, int incy)
{     
       switch (quad) {
              case 1: 
                   *x = *x - incx;
                   *y = *y + incy;
                   break;
              case 2:
                   *y = *y + incy;
                   break;
              case 3:
                   *x = *x + incx;
                   *y = *y + incy;
                   break;
              case 4:
                   *x = *x - incx;
                   break;
              case 5:
                   break;
              case 6:
                   *x = *x + incx;
                   break;
              case 7:
                   *x = *x - incx;
                   *y = *y - incy;
                   break;
              case 8:
                   *y = *y - incy;
                   break;
              case 9:
                   *x = *x + incx;
                   *y = *y - incy;
                   break;
              default: 
                   break;
       }

       //delta = CalculaIncrementJoystick(x, y, x_ant, y_ant);
       //punt.x = punt.x + x; 
       if ( *x<= 0 ) *x = 0;
       if ( *x >= ww ) *x = ww;
       //punt.y = punt.y + y;
       if ( *y <= 0 ) *y = 0;
       if ( *y >= hw ) *y = hw;
}

// Retorna 1 si el punt (a,b) es dins el rectangle (x,y,w,h)
int MyJoystickThread::IsInside(int a, int b, int x, int y, int w, int h)
{
    if ((x <= a) && (a < x+w) && (y <= b) && (b < y+h)) return 1;
    else return 0;    
}
