/***************************************************************************
 *   Copyright (C) 2005 by JSRiera			                               *
 *   http://www.xtec.cat/dnee/udc/english/main.html		          		   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 *   YOU CAN NOT USE THIS SOURCE FILE OR MODIFIED VERSION FOR ANY          *
 *   COMMERCIAL PRODUCTS!                                                  *
 *                                                                         *
 ***************************************************************************/

#include "ThreadPolsador.h"
#include <wx/msgdlg.h>


MyPolsadorThread::MyPolsadorThread(CImgProc *cam)
        : wxThread()
{
    m_cam = cam;
	wxFileConfig *pConfig = new wxFileConfig(wxT("Emulador"), wxT("Educaci"),
		wxT(".emulator_config"), wxEmptyString, wxCONFIG_USE_LOCAL_FILE | wxCONFIG_USE_NO_ESCAPE_CHARACTERS | wxCONFIG_USE_RELATIVE_PATH);
	pConfig->Read(wxT("Temps Espera"), &m_tespera, wxT("2000"));
	pConfig->Read(wxT("Temps Repeticio"), &m_trepeticio, wxT("4000"));
	pConfig->Read(wxT("Clic"), &m_clic, false);
	pConfig->Read(wxT("Clic Dreta"), &m_clic_dreta, false);
	pConfig->Read(wxT("Doble Clic"), &m_dbl_clic, false);
	pConfig->Read(wxT("No Clic"), &m_no_clic, false);
	pConfig->Read(wxT("Mostrar Clic"), &m_mostrar, true);
	pConfig->Read(wxT("Avis Sonor"), &m_avis, true);
	pConfig->Read(wxT("Absencia"), &m_absencia, false);
	pConfig->Read(wxT("Sleep"), &gSleep, wxT("35"));
	pConfig->Read(wxT("RF"), &gRf, false);
	pConfig->Read(wxT("Move"), &p_move, false);
	delete pConfig;
        
}

void MyPolsadorThread::OnExit()
{
}

void *MyPolsadorThread::Entry()
{
    int fila, col, tenimImatge; 
	int px, py, pax, pay;
    FT_HANDLE ftHandle;
    FT_STATUS ftStatus;
    DWORD RxBytes = 1;
    DWORD BytesReceived;
    char RxBuffer[256];
    DWORD EventDWord;
    DWORD TxBytes;
    int w, h, pix;

	cercle.GetMousePos (&px, &py);
	m_cam->GetFrameSize (&w, &h);
	
    if (gRf) 
    {	
      m_mostrar = false;  
      ftStatus = FT_Open(0, &ftHandle);
	  if(ftStatus != FT_OK) {
	  // FT_Open failed
	    wxString msg;
	    msg.Printf("Error opening RF device\n");
		//printf("Error opening RF device\n");
	  }
    }


    while (1)
    {
    
         FT_GetStatus(ftHandle,&RxBytes,&TxBytes,&EventDWord);
         if (RxBytes > 0) {
             ftStatus = FT_Read(ftHandle,RxBuffer,RxBytes,&BytesReceived);
             if (ftStatus == FT_OK) {
               	   //if (BytesReceived == RxBytes) {
           	       // FT_Read OK
                   //int num;
                   //num = RxBuffer[0];
                   //if (num == 1 )
                   cercle.EnviaClicRatoli(px, py, m_clic, m_clic_dreta, 
                                                              m_dbl_clic, m_no_clic);                                                    
             //}
             }
             else {
                  // FT_Read Failed
             }
        } 
		cercle.GetMousePos (&px, &py);
		
		if ( TestDestroy() )
			break;
           
		tenimImatge = m_cam->GetColorPosition (0, &col, &fila);
        if ( m_absencia ) tenimImatge = !tenimImatge;
        
        
		if (tenimImatge) {
			// si movem el cursor, borrem el que teniem dibuixat
			if ((pax != px) || (pay != py))  {
                if ( m_mostrar )           
			        cercle.EraseScreen();
            } else {
                if ( m_mostrar )
                {   
       				if (cercle.DrawScreen(atoi(m_tespera), atoi(m_trepeticio), px, py))
				    {
                       if (!gRf && !p_move)                                    
                       cercle.EnviaClicRatoli(px, py, m_clic, m_clic_dreta, 
                                                              m_dbl_clic, m_no_clic);                                   
                       if ( m_avis ) wxBell();

                       if ( p_move ) 
                       {
                          pix = m_cam->GetPixelsNoZero (0, 0, w, h);
                          if (pix > 10)
                          {
                             cercle.EnviaClicRatoli(px, py, m_clic, m_clic_dreta, 
                                                              m_dbl_clic, m_no_clic);                                                    
                          }
                       }
                    }
                }
                else
                {                  
       				if (cercle.WaitClic(atoi(m_tespera), atoi(m_trepeticio)))
				    {
                       if (!gRf && !p_move)                                  
                       cercle.EnviaClicRatoli(px, py, m_clic, m_clic_dreta, 
                                                              m_dbl_clic, m_no_clic);                                   
                       if ( m_avis ) wxBell();

                       if ( p_move ) 
                       {
                          pix = m_cam->GetPixelsNoZero (0, 0, w, h);
                          if (pix > 10)
                          {
                             cercle.EnviaClicRatoli(px, py, m_clic, m_clic_dreta, 
                                                              m_dbl_clic, m_no_clic);                                                    
                          }
                       }
                    }
                 }
            }
		}      
		pax = px;
		pay = py;		
        usleep(atoi(gSleep)*1000);
    }

    if (gRf)
        FT_Close(ftHandle);

    return NULL;
}
