/***************************************************************************
 *   Copyright (C) 2005 by JSRiera			                               *
 *   http://www.xtec.cat/dnee/udc/english/main.html		          		   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 *   YOU CAN NOT USE THIS SOURCE FILE OR MODIFIED VERSION FOR ANY          *
 *   COMMERCIAL PRODUCTS!                                                  *
 *                                                                         *
 ***************************************************************************/

#include "ThreadTauleta.h"


MyTauletaThread::MyTauletaThread(CImgProc *cam)
        : wxThread()
{
    m_cam = cam;
	wxFileConfig *pConfig = new wxFileConfig(wxT("Emulador"), wxT("Educaci"),
		wxT(".emulator_config"), wxEmptyString, wxCONFIG_USE_LOCAL_FILE | wxCONFIG_USE_NO_ESCAPE_CHARACTERS | wxCONFIG_USE_RELATIVE_PATH);
	pConfig->Read(wxT("Temps Espera"), &m_tespera, wxT("2000"));
	pConfig->Read(wxT("Temps Repeticio"), &m_trepeticio, wxT("4000"));
	pConfig->Read(wxT("Clic"), &m_clic, false);
	pConfig->Read(wxT("Clic Dreta"), &m_clic_dreta, false);
	pConfig->Read(wxT("Doble Clic"), &m_dbl_clic, false);
	pConfig->Read(wxT("No Clic"), &m_no_clic, false);
	pConfig->Read(wxT("Mostrar Clic"), &m_mostrar, true);
	pConfig->Read(wxT("Avis Sonor"), &m_avis, true);
	pConfig->Read(wxT("Invertir Vertical"), &m_vert, true);
	pConfig->Read(wxT("Invertir Horitzontal"), &m_horz, false);
	pConfig->Read(wxT("Tp1x"), &p1x, wxT("0"));
	pConfig->Read(wxT("Tp1y"), &p1y, wxT("0"));
	pConfig->Read(wxT("Tp2x"), &p2x, wxT("0"));
	pConfig->Read(wxT("Tp2y"), &p2y, wxT("0"));
	pConfig->Read(wxT("Tp3x"), &p3x, wxT("0"));
	pConfig->Read(wxT("Tp3y"), &p3y, wxT("0"));
	pConfig->Read(wxT("Tp4x"), &p4x, wxT("0"));
	pConfig->Read(wxT("Tp4y"), &p4y, wxT("0"));
	pConfig->Read(wxT("Sleep"), &gSleep, wxT("35"));
	pConfig->Read(wxT("RF"), &gRf, false);
	delete pConfig;

	Display *dpy = XOpenDisplay(0);
	assert(dpy);
	Window root_window = XRootWindow(dpy, 0);
	XWindowAttributes att;
	XGetWindowAttributes(dpy, root_window, &att);
    cy = att.height;
    cx = att.width;
  	XCloseDisplay(dpy);


}

void MyTauletaThread::OnExit()
{
}

void *MyTauletaThread::Entry()
{
    int fila, col, tenimImatge; 
	//POINT punt, puntAnt;
	int px, py, pax, pay;
	int w, h;
	int x, y;
    FT_HANDLE ftHandle;
    FT_STATUS ftStatus;
    DWORD RxBytes = 1;
    DWORD BytesReceived;
    char RxBuffer[256];
    DWORD EventDWord;
    DWORD TxBytes;

	m_cam->GetFrameSize (&w, &h);
	
	trans.inici_calcul_matriu(atoi(p1x),atoi(p1y),atoi(p2x),atoi(p2y),
                     atoi(p3x),atoi(p3y),atoi(p4x),atoi(p4y),w,h);
	
	cercle.GetMousePos(&px, &py);
	
    if (gRf) 
    {	
      m_mostrar = false;  
      ftStatus = FT_Open(0, &ftHandle);
	  if(ftStatus != FT_OK) {
	  // FT_Open failed
	    wxString msg;
	    msg.Printf(_T("Error opening RF device\n"));
		//printf("Error opening RF device\n");
	  }
    }
	

    while (1)
    {
         FT_GetStatus(ftHandle,&RxBytes,&TxBytes,&EventDWord);
         if (RxBytes > 0) {
             ftStatus = FT_Read(ftHandle,RxBuffer,RxBytes,&BytesReceived);
             if (ftStatus == FT_OK) {
               	   //if (BytesReceived == RxBytes) {
           	       // FT_Read OK
                   //int num;
                   //num = RxBuffer[0];
                   //if (num == 1 )
                   cercle.EnviaClicRatoli(px, py, m_clic, m_clic_dreta, 
                                                              m_dbl_clic, m_no_clic);                                                    
             //}
             }
             else {
                  // FT_Read Failed
             }
        } 

		cercle.GetMousePos(&px, &py);
		
		if ( TestDestroy() )
			break;
           
        tenimImatge = m_cam->GetColorPosition (0, &col, &fila);
        
		if (tenimImatge) {
			// si movem el cursor, borrem el que teniem dibuixat
			if ((pax != px) || (pay != py)) {
                if ( m_mostrar )           
			        cercle.EraseScreen();
            } else {
                if ( m_mostrar )
                {   
       				if (cercle.DrawScreen(atoi(m_tespera), atoi(m_trepeticio), px, py))
				    {
                       if (!gRf)                                    
                       cercle.EnviaClicRatoli(px, py, m_clic, m_clic_dreta, 
                                                              m_dbl_clic, m_no_clic);                                   
                       if ( m_avis ) wxBell();
                    }
                }
                else
                {                  
       				if (cercle.WaitClic(atoi(m_tespera), atoi(m_trepeticio)))
				    {
                       if (!gRf)                                    
                       cercle.EnviaClicRatoli(px, py, m_clic, m_clic_dreta, 
                                                              m_dbl_clic, m_no_clic);                                   
                       if ( m_avis ) wxBell();
                    }
                 }
            }
            x = trans.ulldc_matriu_x(col, fila);
            y = trans.ulldc_matriu_y(col, fila);
            if ( !m_vert )
               y = h - y;
            if ( m_horz ) 
               x = w - x;
 			cercle.SetMousePos((x*cx)/w, (y*cy)/h);
		}      
		pax = px; pay = py;
        usleep(atoi(gSleep)*1000);
    } 
    if (gRf)
        FT_Close(ftHandle);
    return NULL;
}
